%dat=textread('patch1.txt');
clear distance scan tri
ddat=diff(dat);
for n=1:length(ddat)
  distance(n)=norm(ddat(n,:));
end

med_distance=median(distance);
l=1;
point_ndx=1;
for n=1:length(distance)
  if distance(n)>3*med_distance
    l=l+1;
    point_ndx=1;
  end
  scan(l).points(point_ndx,:)=dat(n+1,:);
  scan(l).vertices(point_ndx)=n+1;
  point_ndx=point_ndx+1;
end
clf
plot3(dat(:,1),dat(:,2),dat(:,3),'.')
axis equal
axis vis3d
cameratoolbar
hold on

for line_ndx=1:length(scan)
  plot3(...
    scan(line_ndx).points(1,1),...
    scan(line_ndx).points(1,2),...
    scan(line_ndx).points(1,3),...
    'ro');
  plot3(...
    scan(line_ndx).points(end,1),...
    scan(line_ndx).points(end,2),...
    scan(line_ndx).points(end,3),...
    'go');
end

t=1;
for line_ndx=1:length(scan)-1
  line_ndx
  for point_ndx=1:length(scan(line_ndx).points)-1
    
    tri(t,[1 2])=[...
        scan(line_ndx).vertices(point_ndx)...
        scan(line_ndx).vertices(point_ndx+1)];
    this_point=[...
        scan(line_ndx).points(point_ndx,1),...
        scan(line_ndx).points(point_ndx,2),...
        scan(line_ndx).points(point_ndx,3)];
      
    min_ndx=NaN;
    min_distance1*med_distance;
    min_distance2=3*med_distance;
    for p=1:length(scan(line_ndx+1).points)
      other_point=[...
          scan(line_ndx+1).points(p,1),...
          scan(line_ndx+1).points(p,2),...
          scan(line_ndx+1).points(p,3)];
      distance=norm(diff([this_point;other_point]));
      if distance<min_distance2  % closer than either so far
        if distance<min_distance1 % close than BOTH so far
          min_distance2=min_distance1;
          min_distance1=distance
          min_ndx2=min_ndx1;
          min_ndx1=scan(line_ndx+1).vertices(p);
        else
          min_distance2=distance
          min_ndx2=scan(line_ndx+1).vertices(p);
        end
      end
    end
    tri(t,[3])=min_ndx;
    t=t+1;
  end
end

tri(:,3)
clf
t1=trimesh(tri,dat(:,1),dat(:,2),dat(:,3),'edgecolor','red','facecolor','black')
  