function make_colourbar(r)
% make_colourbar - specify min,step and max values as vector ie
% [-10:2:10]
figure(1)
clf


[x,y]=meshgrid(r,1:2);
contourf(x,y,[r;r],[r])
set(gca,'ytick',[])
set(gca,'xtick',[r])
pos=get(gca,'position');
set(gca,'position',[pos(1) pos(2) pos(3) 0.1])
exportfig(gcf,['colourbar.eps'],'format','eps2','color','cmyk','preview','none')
print('-djpeg',['colourbar.jpg'])
