%function [x,y]=reduce_outline(x,y,amount);
% take all points and reduce them inwards (towards the origin at 0,0) to
% compensate for probe radius

x1=[x;x(1)];
y1=[y;y(1)];
dx=diff(x1);
dy=diff(y1);

c=[dx + j*dy];

ang=angle(c)-pi/2;
dx2=1*cos(ang);
dy2=1*sin(ang);

clf
%quiver(x,y,dx2,dy2)
axis equal

x2=x+dx2;
y2=y+dy2;
plot(x,y,'.');
hold on
plot(x2,y2,'r.');



